"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _LocaleProvider = require("./LocaleProvider");

class LocaleSwitch extends _react.Component {
  constructor(...args) {
    var _this;

    _this = super(...args);
    (0, _defineProperty2.default)(this, "handleChange",
    /*#__PURE__*/
    function () {
      var _ref = (0, _asyncToGenerator2.default)(function* (locale) {
        const {
          onError,
          onChange,
          localeProvider
        } = _this.props;

        try {
          yield localeProvider.setLocale(locale);

          if (onChange) {
            onChange(locale);
          }
        } catch (e) {
          if (onError) {
            onError(e);
          }
        }
      });

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }());
  }

  render() {
    const {
      children,
      localeProvider
    } = this.props;
    return children({
      locale: localeProvider.getLocale(),
      changeLocale: this.handleChange
    });
  }

}

(0, _defineProperty2.default)(LocaleSwitch, "defaultProps", {
  onError: undefined,
  onChange: undefined
});

var _default = (0, _react.forwardRef)((props, ref) => _react.default.createElement(_LocaleProvider.LocaleProviderConsumer, null, ({
  localeProvider
}) => _react.default.createElement(LocaleSwitch, (0, _extends2.default)({}, props, {
  localeProvider: localeProvider,
  ref: ref
}))));

exports.default = _default;
//# sourceMappingURL=LocaleSwitch.js.map