"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = exports.LocaleProviderConsumer = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _translateMaker = _interopRequireDefault(require("translate-maker"));

var _createContext = (0, _react.createContext)({}),
    Provider = _createContext.Provider,
    Consumer = _createContext.Consumer;

var LocaleProviderConsumer = Consumer;
exports.LocaleProviderConsumer = LocaleProviderConsumer;

var LocaleProvider =
/*#__PURE__*/
function (_Component) {
  (0, _inheritsLoose2.default)(LocaleProvider, _Component);

  function LocaleProvider(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "t", function (path, attrs, defaultValue) {
      return _this.get(path, attrs, defaultValue);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "dataChanged", function () {
      _this.forceUpdate();
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "localeChanged", function () {
      _this.forceUpdate();
    });
    var translate = props.translate,
        locale = props.locale,
        namespace = props.namespace,
        children = props.children,
        controlled = props.controlled,
        rest = (0, _objectWithoutPropertiesLoose2.default)(props, ["translate", "locale", "namespace", "children", "controlled"]);
    var instance = translate || new _translateMaker.default(rest);
    _this.state = {
      translate: instance
    };

    if (locale) {
      instance.setLocale(locale, namespace);
    }

    return _this;
  }

  var _proto = LocaleProvider.prototype;

  _proto.componentDidMount = function componentDidMount() {
    var translate = this.state.translate;
    translate.on('locale', this.localeChanged);
    translate.on('changed', this.dataChanged);
  };

  _proto.componentWillReceiveProps = function componentWillReceiveProps(newProps) {
    var _this$props = this.props,
        locale = _this$props.locale,
        namespace = _this$props.namespace;
    var translate = this.state.translate;

    if (newProps.controlled) {
      if (newProps.locale !== locale) {
        translate.setLocale(newProps.locale, newProps.namespace);
      } else if (newProps.locale && newProps.namespace !== namespace) {
        translate.setLocale(newProps.locale, newProps.namespace);
      }
    }
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    var translate = this.state.translate;
    translate.removeListener('locale', this.localeChanged);
    translate.removeListener('changed', this.dataChanged);
  };

  _proto.getLocale = function getLocale() {
    var translate = this.state.translate;
    return translate.getLocale();
  };

  _proto.setLocale =
  /*#__PURE__*/
  function () {
    var _setLocale = (0, _asyncToGenerator2.default)(
    /*#__PURE__*/
    _regenerator.default.mark(function _callee(locale) {
      var controlled, translate;
      return _regenerator.default.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              controlled = this.props.controlled;

              if (!controlled) {
                _context.next = 3;
                break;
              }

              throw new Error('LocaleProvider is set as controlled component. If you want to use setLocale please set controlled = false');

            case 3:
              translate = this.state.translate;
              _context.next = 6;
              return translate.setLocale(locale);

            case 6:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, this);
    }));

    return function setLocale(_x) {
      return _setLocale.apply(this, arguments);
    };
  }();

  _proto.get = function get(path, attrs, defaultValue) {
    var translate = this.state.translate;
    return translate.get(path, attrs, defaultValue);
  };

  _proto.set = function set(path, value) {
    var translate = this.state.translate;
    return translate.set(path, value);
  };

  _proto.render = function render() {
    var children = this.props.children;
    return _react.default.createElement(Provider, {
      value: {
        localeProvider: this
      }
    }, children);
  };

  return LocaleProvider;
}(_react.Component);

exports.default = LocaleProvider;
(0, _defineProperty2.default)(LocaleProvider, "defaultProps", {
  controlled: true
  /*
  locale: undefined,
  namespace: undefined,
  locales: undefined,
  cache: undefined,
  data: undefined,
  adapter: undefined,
  dotNotation: undefined,
  mode: undefined,
  references: undefined,
  variables: undefined,
  combinations: undefined,
  filters: undefined,
  translate: undefined,
  */

});
//# sourceMappingURL=LocaleProvider.js.map