"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = exports.NamespaceConsumer = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _createContext = (0, _react.createContext)({}),
    Provider = _createContext.Provider,
    Consumer = _createContext.Consumer;

var NamespaceConsumer = Consumer;
exports.NamespaceConsumer = NamespaceConsumer;

var Namespace =
/*#__PURE__*/
function (_Component) {
  (0, _inheritsLoose2.default)(Namespace, _Component);

  function Namespace() {
    return _Component.apply(this, arguments) || this;
  }

  var _proto = Namespace.prototype;

  _proto.getPath = function getPath() {
    var _this$props = this.props,
        path = _this$props.path,
        compose = _this$props.compose,
        namespace = _this$props.namespace;

    if (!compose || !path) {
      return path;
    }

    if (namespace) {
      var parentPath = namespace.getPath();

      if (parentPath) {
        return parentPath + "." + path;
      }
    }

    return path;
  };

  _proto.render = function render() {
    var children = this.props.children;
    return _react.default.createElement(Provider, {
      value: {
        namespace: this
      }
    }, children);
  };

  return Namespace;
}(_react.Component);

(0, _defineProperty2.default)(Namespace, "defaultProps", {
  path: undefined,
  compose: undefined,
  namespace: undefined
});

var _default = (0, _react.forwardRef)(function (props, ref) {
  return _react.default.createElement(Consumer, null, function (_ref) {
    var namespace = _ref.namespace;
    return _react.default.createElement(Namespace, (0, _extends2.default)({}, props, {
      namespace: namespace,
      ref: ref
    }));
  });
});

exports.default = _default;
//# sourceMappingURL=Namespace.js.map