"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _LocaleProvider = require("./LocaleProvider");

var _Namespace = require("./Namespace");

var ProvideTranslate =
/*#__PURE__*/
function (_Component) {
  (0, _inheritsLoose2.default)(ProvideTranslate, _Component);

  function ProvideTranslate() {
    var _this;

    for (var _len = arguments.length, _args = new Array(_len), _key = 0; _key < _len; _key++) {
      _args[_key] = arguments[_key];
    }

    _this = _Component.call.apply(_Component, [this].concat(_args)) || this;
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)((0, _assertThisInitialized2.default)(_this)), "translate", function (path) {
      var localeProvider = _this.props.localeProvider;

      for (var _len2 = arguments.length, args = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
        args[_key2 - 1] = arguments[_key2];
      }

      return localeProvider.get.apply(localeProvider, [_this.getPath(path)].concat(args));
    });
    return _this;
  }

  var _proto = ProvideTranslate.prototype;

  _proto.getPath = function getPath(path) {
    var _this$props = this.props,
        namespace = _this$props.namespace,
        ignoreNamespace = _this$props.ignoreNamespace;

    if (!namespace || ignoreNamespace) {
      return path;
    }

    var parentPath = namespace.getPath();

    if (!parentPath) {
      return path;
    }

    return parentPath + "." + path;
  };

  _proto.render = function render() {
    var children = this.props.children;
    return children(this.translate);
  };

  return ProvideTranslate;
}(_react.Component);

(0, _defineProperty2.default)(ProvideTranslate, "defaultProps", {
  ignoreNamespace: false
});

var _default = (0, _react.forwardRef)(function (props, ref) {
  return _react.default.createElement(_LocaleProvider.LocaleProviderConsumer, null, function (_ref) {
    var localeProvider = _ref.localeProvider;
    return _react.default.createElement(_Namespace.NamespaceConsumer, null, function (_ref2) {
      var namespace = _ref2.namespace;
      return _react.default.createElement(ProvideTranslate, (0, _extends2.default)({}, props, {
        localeProvider: localeProvider,
        namespace: namespace,
        ref: ref
      }));
    });
  });
});

exports.default = _default;
//# sourceMappingURL=ProvideTranslate.js.map