"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.prepareParams = prepareParams;
exports.default = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _react = _interopRequireWildcard(require("react"));

var _server = require("react-dom/server");

var _LocaleProvider = _interopRequireWildcard(require("./LocaleProvider"));

var _Namespace = require("./Namespace");

function prepareParams(params, localeProvider) {
  var newParams = {};
  var changed = false;
  Object.keys(params).forEach(function (key) {
    var value = params[key];
    var isReactElement = (0, _react.isValidElement)(value);

    if (!isReactElement) {
      newParams[key] = value;
    } else {
      changed = true;
      var _localeProvider$props = localeProvider.props,
          children = _localeProvider$props.children,
          locale = _localeProvider$props.locale,
          rest = (0, _objectWithoutPropertiesLoose2.default)(_localeProvider$props, ["children", "locale"]);
      newParams[key] = (0, _server.renderToStaticMarkup)(_react.default.createElement(_LocaleProvider.default, rest, value));
    }
  });
  return changed ? newParams : params;
}

var Translate =
/*#__PURE__*/
function (_Component) {
  (0, _inheritsLoose2.default)(Translate, _Component);

  function Translate() {
    return _Component.apply(this, arguments) || this;
  }

  var _proto = Translate.prototype;

  _proto.getPath = function getPath() {
    var _this$props = this.props,
        path = _this$props.path,
        $namespace = _this$props.$namespace;

    if (!$namespace) {
      return path;
    }

    var parentPath = $namespace.getPath();

    if (!parentPath) {
      return path;
    }

    return parentPath + "." + path;
  };

  _proto.render = function render() {
    var _this$props2 = this.props,
        path = _this$props2.path,
        $namespace = _this$props2.$namespace,
        $localeProvider = _this$props2.$localeProvider,
        defaultValue = _this$props2.defaultValue,
        params = _this$props2.params,
        children = _this$props2.children,
        html = _this$props2.html,
        rest = (0, _objectWithoutPropertiesLoose2.default)(_this$props2, ["path", "$namespace", "$localeProvider", "defaultValue", "params", "children", "html"]);
    var updatedDefaultValue = !defaultValue && typeof children !== 'function' ? children : defaultValue;
    var updatedParams = prepareParams(params || rest, $localeProvider);
    var text = $localeProvider.get(this.getPath(), updatedParams, updatedDefaultValue);

    if (typeof children === 'function') {
      return children(text);
    }

    if (html) {
      return _react.default.createElement("span", {
        dangerouslySetInnerHTML: {
          __html: text
        }
      });
    }

    return text;
  };

  return Translate;
}(_react.Component);

(0, _defineProperty2.default)(Translate, "defaultProps", {
  defaultValue: undefined,
  description: undefined,
  params: undefined,
  children: undefined,
  $namespace: undefined,
  html: false
});

var _default = (0, _react.forwardRef)(function (props, ref) {
  return _react.default.createElement(_LocaleProvider.LocaleProviderConsumer, null, function (_ref) {
    var localeProvider = _ref.localeProvider;
    return _react.default.createElement(_Namespace.NamespaceConsumer, null, function (_ref2) {
      var namespace = _ref2.namespace;
      return _react.default.createElement(Translate, (0, _extends2.default)({}, props, {
        $localeProvider: localeProvider,
        $namespace: namespace,
        ref: ref
      }));
    });
  });
});

exports.default = _default;
//# sourceMappingURL=Translate.js.map